'***************************************************************************
'                            ALARM.BAS
'                            16.12.2003
'(c) Ing.Buero Lehmann, Fuerstenbergstrasse 8a, D-77756 Hausach, Germany
'   Tel. +49 (0)7831 452     Fax +49 (0)7831 96428    www.iL-online.de
'***************************************************************************

'This program demonstrates the using of the buzzer, display and button.
'All JP2s must be set to the right, JP3 (T0 to T2) set to the left and T3 put
'to JP1 to select buzzer.
'T0 starts the down counter, T1 stops it and T2 resets the counter. On timeout
'(counter=0) the buzzer is activated for 1 second.
  $list /M_OBJ
  $obj2hex
         xtal 4
         define device 16F84, wdt_off, xt_osc
         
         define counter=$20

         define startkey = ra,0
         define stopkey = ra,1
         define resetkey = ra,2
         define buzzer = ra,3
         
cold:
         goto start
                  
init:
         tris rb,0                     'all RBs as output for display
         tris ra,%11110111             'RA3 output for buzzer, rest input
         return
         
'converts value in counter into segment information (pattern)
disp: 
         if counter=0 then output rb,%00111111
         if counter=1 then output rb,%00000110 
         if counter=2 then output rb,%01011011 
         if counter=3 then output rb,%01001111 
         if counter=4 then output rb,%01100110 
         if counter=5 then output rb,%01101101 
         if counter=6 then output rb,%01111101 
         if counter=7 then output rb,%00000111
         if counter=8 then output rb,%01111111
         if counter=9 then output rb,%01101111
         return
         
start:
         gosub init
         let counter=9
         gosub disp
loop:
         if resetkey=0 then goto start 'Resets alarm timer
         if startkey=1 then goto loop  'wait 'til start key is pressed
run:
         if stopkey=0 then goto loop   'if stop, wait in idle loop
         wait 1000                     'wait for one second
         dec counter                   'same as COUNTER=COUNTER-1, but better
         gosub disp
         if counter=0 then goto beep   'ready, then make noise
         goto run
         
beep:
         lofreq buzzer,800,1000         '800Hz for 1 second         
         goto start