'***************************************************************************
'                            CQ_CALL.BAS
'                            16.12.2003
'(c) Ing.Buero Lehmann, Fuerstenbergstrasse 8a, D-77756 Hausach, Germany
'   Tel. +49 (0)7831 452     Fax +49 (0)7831 96428    www.iL-online.de
'***************************************************************************
'
'Send your cq-call automatically
'
'This program demonstrates the using of the buzzer and button. The morse table
'is implemented by the use of DATA and READDATA.
'All JP2s must be set to the right, JP3 (T0 to T2) set to the left and T3 put
'to JP1 to select buzzer.
'T0 starts the sending your cq-call

         $obj2hex                      'generates a hex file optionally
         
         xtal 4
         define device 16F84, wdt_off, xt_osc
         
         define counter=$20
         define duration=$21           'point or dash (short or long)
         define char = $22             'character read from call-table
         define value = $23            'values read out of morse table
         define ii = $24               'variable in FOR-NEXT loop
         define jj = $25               'counter for group 5
         
         define pointer = $30 as word  'because we read 2 tables at the same time
         
         define key_0 = ra,0
         define key_1 = ra,1
         define key_2 = ra,2
         define buzzer = ra,3
         
cold:
         res t0cs                      'this enables TMR0 for better random solutions
         goto start
                  
init:
         tris ra,%11110111             'RA3 output for buzzer, rest input
         return
         
beep:
         if value=0 then lofreq buzzer,800,100   '800Hz         
         if value=1 then lofreq buzzer,800,300
         wait 100                      'pause between each item
         return

ascii2morse:
         restore morsetable            'now we search for the right character
asc2morse:
         readdata value                
         if value="?" then return      'no match found, ignore character
         if value<>char then goto asc2morse      'look for next entry  
         readdata counter              'match, get numbers of entries
         for ii=1 to counter
           readdata value              'read 1 or 0
           gosub beep                  'generate desired beep
         next ii
         return
         
start:
         gosub init
         if key_0 = 0 then goto start  'wait until all keys are released
         if key_1 = 0 then goto start
         if key_2 = 0 then goto start
         let pointer=0
         let jj=0
loop:         
         if key_0 = 0 then goto cq_call1         
         if key_1 = 0 then goto cq_call2
         if key_2 = 0 then goto groups
         goto loop
         
cq_call1:
         restore cq_call_t1
         goto cq_call
cq_call2:
         restore cq_call_t2
cq_call:
         readdata char         
         let pointer=datptr_           'keep actual data pointer
         if char=0 then goto start     'all finished
         gosub ascii2morse             'this subroutine changes data pointer
         wait 500                      'pause between each character
         let datptr_ = pointer         'restore data pointer
         goto cq_call

'generates a random block of 5 characters
groups:
         random char                   'generates a random character
groups1:                               'different times, because we want only
         random char                   'a subset of all numbers
groups2:
         random char                  
         if char<"0" then goto groups1 'not valid
         if char>"z" then goto groups2 'also not valid
         if char>$60 then goto ok
         if char<$3a then goto ok
         goto groups
ok:
         gosub ascii2morse             'generate morse code
         wait 500                      'pause between each character
         inc jj
         if jj<5 then goto groups
         goto start
         
'-------- Table with CALLs and ascii to morse converter                  
cq_call_t1:
data     "dd4gs",0           'your call, only lower case with limiter 0
cq_call_t2:
data     "dj7fj",0           'alternativ call

morsetable:
'Here is the translation table for ascii characters to morse code
data     "a",2,0,1           ' .-
data     "b",4,1,0,0,0       ' -...
data     "c",4,1,0,1,0       ' -.-.
data     "d",3,1,0,0         ' -..
data     "e",1,0             ' .
data     "f",4,0,0,1,0       ' ..-.
data     "g",3,1,1,0         ' --.
data     "h",4,0,0,0,0       ' ....
data     "i",2,0,0           ' ..
data     "j",4,0,1,1,1       ' .---
data     "k",4,1,0,1         ' -.-
data     "l",4,0,1,0,0       ' .-..
data     "m",2,1,1           ' --
data     "n",2,1,0           ' -.
data     "o",3,1,1,1         ' ---
data     "p",4,0,1,1,0       ' .--.
data     "q",4,1,1,0,1       ' --.-
data     "r",3,0,1,0         ' .-.
data     "s",3,0,0,0         ' ...
data     "t",1,1             ' -
data     "u",3,0,0,1         ' ..-
data     "v",4,0,0,0,1       ' ...-
data     "w",3,0,1,1         ' .--
data     "x",4,1,0,0,1       ' -..-
data     "y",4,1,0,1,1       ' -.--
data     "z",4,1,1,0,0       ' --..         
data     "1",5,0,1,1,1,1     ' .----
data     "2",5,0,0,1,1,1     ' ..---
data     "3",5,0,0,0,1,1     ' ...--
data     "4",5,0,0,0,0,1     ' ....-
data     "5",5,0,0,0,0,0     ' .....
data     "6",5,1,0,0,0,0     ' -....
data     "7",5,1,1,0,0,0     ' --...
data     "8",5,1,1,1,0,0     ' ---..
data     "9",5,1,1,1,1,0     ' ----.
data     "0",5,1,1,1,1,1     ' -----
data     "?"                 'End of table