'***************************************************************************
'                            REACTION.BAS
'                            22.12.2003
'   (c) Ing.Buero Lehmann, Fuerstenbergstrasse 8a, D-77756 Hausach
'  Tel. +49 (0)7831 452,  Fax. +49 (0)7831 96428   www.iL-online.de
'***************************************************************************
' also suitable for DEMO version, change DEVICE 16F84 into 16C83
'
'Measures your delay between recognition and response
'
'By random a number 1, 2, 3 or 4 is displayed then you have to quit button
'1,2,3 or 4. The time between appearence of the number and your response is 
'measuered and displayed. Press RESET to start.
'
'JP3 all to the left
'
'IMPORTANT if used with EPIC1
'LCD connection must be lightly modified. Because EPIC1 and easyPIC has different
'connectors for the lcd EPIC1 needs some modifications. Connect pin 5 of the lcd
'directly to ground (pin 1). Do not connect it with PIC. Pin 4 of the pcb connector
'must be left open. Pin 5 of pcb connector must be connect to pin 4 of the lcd; all
'other pins must not be modified.
'
'                                                +-----------+
'                                                |           | 
'LCD connector   14  13  12  11  10  9  8  7  6  5  4  3  2  1  
'                 |   |   |   |               |     |  |  |  |
'                 |   |   |   |               |     |  |  |  |
'                 |   |   |   |               |  +--+  |  |  |
'EPIC1            |   |   |   |               |  |     |  |  |
'pcb connector   14  13  12  11  10  9  8  7  6  5  4  3  2  1 
'
'
         $obj2hex                      'generates a hex file optionally
         
         xtal 4
         define device 16F84, wdt_off, xt_osc
         
         define counter=$20 as word    'response time in ms
         define number=$22             '1,2 or 3
         define key=$23
         define delaytime=$24          'delay time 
         define ii=$25                 'index in FOR-NEXT
cold:
         wait 500
         res t0cs                      'better random seed
         lcdinit rb,2,20,uplinesx
         goto start

init:    
         tris ra,%11111111             'all input
         return
         
start:
         gosub init         
         lcdwrite 1,1,"press button ->0"
         lcdwrite 2,1,"response 0000 ms"
         wait 2000
         random delaytime
         for ii=0 to delaytime         'max. 13 sec
           wait 50
         next ii
         random number
         let number=number and 3
         inc number                    'now between 1 and 4
         let number=number or $30      'now it is an ascii character
         lcdwrite 1,16,number,#        'show it
         let number=number and 15
         let counter=0
loop:
         wait 1                        '1 ms resolution
         inc counter
         if counter>9999 then goto stop
         input ra,key                  'read key
         let key=key and 15            'only lower bits
         let key=key xor 15            '1's complement
         if key=4 then let key=3       'turn bit position to value
         if key=8 then let key=4         
         if key=0 then goto loop
         if key<>number then goto loop 'wrong key pressed
stop:
         lcdwrite 2,9,counter

ende:    
         goto ende                     'press RESET for new game         